function [records]= ...
    n2_truncate(ti,gs,gm,cm,records,reclength,gaps,truncin)


records_old=records; 
trunc=records;
sa=1:size(ti,1);

if trunc>truncin
    trunc=truncin
end

while ~isempty(trunc)
    %truncate
    if ~isempty(trunc)
        gs=gs(:,1:trunc);
        gm=gm(:,1:trunc);
        cm=cm(:,1:trunc);
        records=trunc;
    end %if

    disp ('number of records');
    disp (records);

    %calculate mean of the records
    avegs=mean(gs(:,:),1);
    avegm=mean(gm(:,:),1);
    avecm=mean(cm(:,:),1);

    %make centered versions of the whole traces
    cgs=gs-repmat(avegs,reclength,1);
    cgm=gm-repmat(avegm,reclength,1);
    ccm=cm-repmat(avecm,reclength,1);
    
    

    %calculate mean over records
    avegs2=trimmean(cgs',25);
    avegm2=trimmean(cgm',25);
    avecm2=trimmean(ccm',25);
    
    %calculate 
    davegs=10*iqr(avegs2);
    davegm=10*iqr(avegm2);
    davecm=10*iqr(avecm2);

    %plot the average traces
    gca=figure(1); whitebg ([0 0 0]);
    set (gca,'Name',['Average Gs Gm Cm']);
    subplot (3,1,1); plot (sa,avegs2,'g',sa(gaps),avegs2(gaps),'ro'); title ('gs')
    subplot (3,1,2); plot (sa,avegm2,'g',sa(gaps),avegm2(gaps),'ro'); title ('gm')
    subplot (3,1,3); plot (sa,avecm2,'g',sa(gaps),avecm2(gaps),'ro'); title ('cm')
    
    gca=figure(2); whitebg ([0 0 0]);
    set (gca,'Name',['Individual Gs Gm Cm']);
    subplot (1,3,1); plot (cgs./davegs+repmat([1:records],reclength,1)); title ('Gs');
    ax=axis; axis([0 reclength 0 (records+1)]);
    subplot (1,3,2); plot (cgm./davegm+repmat([1:records],reclength,1)); title ('Gm');
    ax=axis; axis([0 reclength 0 (records+1)]);
    subplot (1,3,3); plot (ccm./davecm+repmat([1:records],reclength,1)); title ('Cm');
    ax=axis; axis([0 reclength 0 (records+1)]);

    trunc=input ('Truncate data at record? ');
end %while trunc

if ~isempty(trunc)
    records=trunc
end %funtions