%make sample and deltat
sa=1:size(ti,1);

%calculate mean of the records
avegs=mean(gs(:,:),1);
avegm=mean(gm(:,:),1);
avecm=mean(cm(:,:),1);

%center the traces
cgs=gs-repmat(avegs,reclength,1);
cgm=gm-repmat(avegm,reclength,1);
ccm=cm-repmat(avecm,reclength,1);


%make filters and constants
b1=fir1(forder,f1);
b2=fir1(forder,f2);

%scales
cmdisplay=50;
%gsdisplay=1;
%gmdisplay=0.5;

%editing=input('Enable sample editing? (1-yes, 0-no)'); 
editing=0;
%resamplespan=10;

%get the biggest block, crop it
%blocksize=min(diff([0 gaps(:)' reclength])-1)-crop;
blocksize=floor(min(diff([0 gaps(:)' reclength])-1)./1.5);

%set the blocks in which the reliable parts will be found
%the direction is reversed for the parts before the gap

blocks=[gaps(1):-1:gaps(1)-blocksize;
gaps(1):gaps(1)+blocksize;
gaps(2):-1:gaps(2)-blocksize;
gaps(2):gaps(2)+blocksize;
gaps(3):-1:gaps(3)-blocksize;
gaps(3):gaps(3)+blocksize]';

%display the SD of the segments%
gca=figure(2); whitebg([0 0 0]); clf;

subplot (3,1,1); 
snoise=([std(detrend(cm(blocks(:,1),:))) ; std(detrend(cm(blocks(:,2),:))) ; ...
       std(detrend(cm(blocks(:,3),:))) ; std(detrend(cm(blocks(:,4),:))) ; ...
       std(detrend(cm(blocks(:,5),:))) ; std(detrend(cm(blocks(:,6),:))) ]'); 
plot (snoise); xlabel (median(snoise(:))); ylabel ('Noise SD');
disp ('Median Signal noise ');
disp (median(snoise(:)))

subplot (3,1,2); 
plot ([skewness(detrend(cm(blocks(:,1),:))) ; skewness(detrend(cm(blocks(:,2),:))) ; ...
       skewness(detrend(cm(blocks(:,3),:))) ; skewness(detrend(cm(blocks(:,4),:))) ; ...
       skewness(detrend(cm(blocks(:,5),:))) ; skewness(detrend(cm(blocks(:,6),:))) ]'); 
   ylabel ('Skewness');

subplot (3,1,3); 
plot ([kurtosis(detrend(cm(blocks(:,1),:))) ; kurtosis(detrend(cm(blocks(:,2),:))) ; ...
       kurtosis(detrend(cm(blocks(:,3),:))) ; kurtosis(detrend(cm(blocks(:,4),:))) ; ...
       kurtosis(detrend(cm(blocks(:,5),:))) ; kurtosis(detrend(cm(blocks(:,6),:))) ]'); 
   ylabel ('Kutosis'); 


%here we start the trace selection
ss=nan(6,records); %will contain the selected regions
sx=nan(6,records); %will contain the regions lengths
inddd=[]; %will hold the "history" of clicking, together with indc
editedsamples=[];
trashedrecords=[];

%make the random order of the records presentation
[cc,indc]=sort(rand(records,1));
cc=1;


%the loop
loop=true;
figure(3); clf;

while loop
    c=indc(cc);
    %plot the three traces
    gca=figure(3); hold off;
    set (gca,'Name',['Record Number ' int2str(c)]);
    %subplot (3,3,1); plot (sa,cgm(:,c),'b')
    %subplot (3,3,4); plot (sa,cgs(:,c),'b')
    %subplot (3,3,7); plot (sa,ccm(:,c),'b');
    
    %randomize the epoch presentation
    [dd,indd]=sort(rand(6,1));
    inddd=[inddd indd];
    
    %run through the epochs
    for dd=1:6
        d=indd(dd);

        %plotting
        gca=figure (3); 
        set (gca,'Name',['Record ',int2str(c),' Block ',int2str(d), 'Click',int2str(cc)]);
        set (gca,'Color',[0 0 0]); 
        
        bsa=sa(blocks(:,d));
                
        detrendtype='constant';
        bccm=detrend(cm(blocks(:,d),c),detrendtype);
        bfcm1=filtfilt(b1,1,bccm);
        bfcm2=filtfilt(b2,1,bccm);

        %for trend-corrected trace
        bccml=detrend(cm(blocks(:,d),c),'linear');
        bfcml1=filtfilt(b1,1,bccml);
        bfcml2=filtfilt(b2,1,bccml);

        %gs and gm 
        dcgs=detrend(gs(blocks(:,d),c),detrendtype);
        dcgm=detrend(gm(blocks(:,d),c),detrendtype);
        %bcgs=bccm-a(:,c).*dcgs; %demixed with gs
        %bcgm=bccm-a(:,c).*dcgs-b(:,c).*dcgm; %demixed with both
        
        btim=1:size(bccm(:),1);
        
        %calculation of the (a,b) grid for the signal noise
        gridsize=11; s=3;
        A=linspace(-s.*max(abs(a)),s.*max(abs(a)),gridsize); %.*a(:,c);
        B=linspace(-s.*max(abs(b)),s.*max(abs(b)),gridsize); %.*b(:,c);
        signalnoise=zeros(gridsize); 
            for x=1:gridsize
            for y=1:gridsize
                demixed=(detrend(bccm-A(x).*dcgs-B(y).*dcgm));
                signalnoise(x,y)=std(demixed);
                %sigtrend(x,y)=skewness(demixed);
            end
            end
       
        gca=figure(3);
        subplot (2,2,1);
        plot ([std(detrend(cm(blocks(:,1),:))) ; std(detrend(cm(blocks(:,2),:))) ; ...
        std(detrend(cm(blocks(:,3),:))) ; std(detrend(cm(blocks(:,4),:))) ; ...
        std(detrend(cm(blocks(:,5),:))) ; std(detrend(cm(blocks(:,6),:))) ]'); 
        hold on; plot ([c c],[0 10]); hold off; title ('Noise SD');
            
        subplot (2,2,2);
        plot (btim(crop:end-crop),bccm(crop:end-crop),'go','MarkerSize',3); hold on;
        plot (btim(crop:end-crop),bfcm1(crop:end-crop),'b','Linewidth',2); 
        plot (btim(crop:end-crop),bfcm2(crop:end-crop),'r','Linewidth',2); 
        grid on; hold off; ylabel ('Cm'); ax=axis; axis([ax(1:2),-cmdisplay,cmdisplay]);
        title ('Non-demixed Cm');
          
        subplot (2,2,4);
        plot (btim(crop:end-crop),bccml(crop:end-crop),'go','MarkerSize',3); hold on;
        plot (btim(crop:end-crop),bfcml1(crop:end-crop),'b','Linewidth',2); 
        plot (btim(crop:end-crop),bfcml2(crop:end-crop),'r','Linewidth',2); 
        grid on; hold off; ylabel ('Cm'); ax=axis; axis([ax(1:2),-cmdisplay,cmdisplay])
        title ('Detrended non-demixed Cm');

        subplot (2,2,3);
        imagesc(A,B,signalnoise); 
        hold on; plot (a(:,c),b(:,c),'wo'); hold off
        colorbar; xlabel ('demixing gs'); ylabel ('demixing gm');
        title ('Demixed Detrended Signal noise');
        
        
        %clicking part
        x=[];
        while isempty(x) 
            [x,y,key]=(ginput(1));
            if isempty(key)
                key='a'
            end
        switch key 
            case 1
               if x>blocksize-crop 
                   x=blocksize-crop;
               elseif x<crop
                   x=crop;
               end
            case 'a'
               x=blocksize-crop;
            case 'p'
               x=[]; pause; pause; pause;
            case 'q'
                x=nan; break %while; 
            case 'x'
                x=nan; return;
            otherwise
                x=[];
        end %switch
        end %while
    
    if isnan(x) break, end;              
    
    x=round(x);
    sx(d,c)=x;
    ss(d,c)=blocks(x,d);
    end %for dd
    
    %display the region ends
    disp (ss(:,c)');

    %%plot the cm trace        
    %subplot (3,2,5);
    %plot (sa,ccm(:,c),'r'); 

    editedsamplesdisplay=[];
    key='x';            

    while (key~=1)
            %display the three traces with overlaid selections
            gca=figure(3); 
            subplot (2,2,1); 
            plot (sa,cgm(:,c),'b', ...
            sa(ss(1,c):ss(2,c)),cgm(ss(1,c):ss(2,c),c),'co', ...
            sa(ss(5,c):ss(6,c)),cgm(ss(5,c):ss(6,c),c),'mo', ...
            sa(ss(3,c):ss(4,c)),cgm(ss(3,c):ss(4,c),c),'yx', ...
            'MarkerSize',3)
            xlabel ('gm'); 
            
            subplot (2,2,2); 
            plot (sa,cgs(:,c),'b', ...
            sa(ss(1,c):ss(2,c)),cgs(ss(1,c):ss(2,c),c),'co', ...
            sa(ss(5,c):ss(6,c)),cgs(ss(5,c):ss(6,c),c),'mo', ...
            sa(ss(3,c):ss(4,c)),cgs(ss(3,c):ss(4,c),c),'yx', ...
            'MarkerSize',3)
            xlabel ('gs'); 
            
            subplot (2,2,3); 
            ax=axis;
            plot (sa,ccm(:,c),'b', ...
            sa(ss(1,c):ss(2,c)),ccm(ss(1,c):ss(2,c),c),'co', ...
            sa(ss(5,c):ss(6,c)),ccm(ss(5,c):ss(6,c),c),'mo', ...
            sa(ss(3,c):ss(4,c)),ccm(ss(3,c):ss(4,c),c),'yx', ...
            'Markersize',3)
            xlabel ('cm'); 

      
                     
            %display the edited samples in the cm trace
            if ~isempty(editedsamplesdisplay) 
                hold on; plot (editedsamplesdisplay,0,'rx'); hold off; 
            end            
            
            if editing
                title ('Edit mode (press <return> to finish editing):')
                [x,y,key]=ginput(1);
                x=round(x);
                if ~isempty(key)
                    dx=0;
                    while (dx<=0) | (dx>reclength)
                        dx=x+round(randn*resamplespan); disp (dx);
                    end %while
                    editedsamplesdisplay=[editedsamplesdisplay x];
                    editedsamples=[editedsamples; [c x dx cm(x,c) gs(x,c) gm(x,c)]];
                    ccm(x,c)=ccm(dx,c); cm(x,c)=cm(dx,c);
                    cgm(x,c)=cgm(dx,c); gm(x,c)=gm(dx,c);
                    cgs(x,c)=cgs(dx,c); gs(x,c)=gs(dx,c);
                end %if
            disp(editedsamplesdisplay');            
            end %if editing

           gca=figure(3); 
           set (gca,'Name',['Click ' int2str(cc) '/' int2str(records)]);
           subplot (2,2,4); hist (sx(:)',[0:100:blocksize]); 
           title ('<return>/click to go on, (R)repeat, (T)trash (X)exit')
           
                      
           [x,y,key]=ginput(1);
           if isempty(key) %return
              key=1;
           end
           
           switch key
               case 1
                    cc=cc+1;
               case 't' 
                    trashedrecords=[trashedrecords cc];
                    cc=cc+1;
                    key=1;
               case 'x'
                    loop=false;
                    key=1;
               case 'r'
                   key=1;
           end %if

           
           
           if cc>records %all records have been processed
                loop=false;
           end %if
    end %while isempty
end %loop

gca=figure(4); 
set (gca,'Name','Selection Histogram');
subplot (2,2,1); plot (sx','.');
subplot (2,2,2); boxplot((sx'));
subplot (2,2,3); hist (sx',linspace(0,blocksize,10)) 
subplot (2,2,4); plot (mean(sx));


end %function
