function [tau,tause]=n5_estimatetau(y,t,Tstep,tauest,onesidelength,trimperc);
%[tau tause]=n5_estimatetau(y,t,Tstep,tauest,onesidelength,trimperc);
%uses non-linear regression to estimate the tail from the signal



y=y([Tstep-onesidelength:Tstep,Tstep+3:Tstep+onesidelength],:);
t=t([Tstep-onesidelength:Tstep,Tstep+3:Tstep+onesidelength],:);
ymean=(trimmean(detrend(y,'linear')',trimperc))'; 
yy=detrend(y,'constant');
tt=repmat(t,1,size(y,2));
Tstep=onesidelength+1;


%the estimator for the trimmedmean of detrended data
%will serve as the initial estimate
[beta_tm,sebeta_tm,yhat_tm]=estimatetransient(ymean,t,Tstep,tauest, ...
    [0 0 0 0 ymean(Tstep)]');

gca=figure(5);
set(gca,'Name','Fit to the trace');
%subplot (1,3,1); 
plot (t,ymean,'-',t,yhat_tm,'o'); 

tau=beta_tm(6);
tause=sebeta_tm(6);


%no need for this 
if false
%this is not necessary
%now let us take the whole set of centered data and see what can be fit
[beta_all,sebeta_all,yhat_all]=estimatetransient(yy,tt,Tstep,beta_tm(6));

%rerun on the detrended
[beta_tm,sebeta_tm,yhat_tm]=estimatetransient(ymean,t,Tstep,beta_all(6), ...
    beta_all);

subplot (1,3,2); plot (t,yy,'b.',t,yhat_all(1:size(y,1)),'ro-'); 
subplot (1,3,3); plot (t,ymean,'-',t,yhat_tm,'o-'); 

tau=[beta_tm(6) beta_tm(6)];
tause=[sebeta_all(6) sebeta_tm(6)];
end

%disp('Estimates on centered raw data [est,se]');
%disp(beta_all')
%disp(sebeta_all')
%disp('Estimates on mean detrended data');
%disp(beta_tm');
%disp(sebeta_tm');

%running on individual traces ..
%for c=1:size(y,2)
%    [beta_c1(:,c),sebeta_c(:,c)]=estimatetransient(y(:,c),t,Tstep,beta_tm(6)/5);
%    [beta_c2(:,c),sebeta_c(:,c)]=estimatetransient(y(:,c),t,Tstep,beta_tm(6));
%    [beta_c3(:,c),sebeta_c(:,c)]=estimatetransient(y(:,c),t,Tstep,beta_tm(6)*10);
%end

end %function