function [par,separ,modelvar,datapointsused,a1,b1,modelE,modelresid]=n6_getsteps ...
    (cm,gs,gm,time,ss,records,gap,lag,tau,modelsel,plotting);
%function [par,separ,modelvar,datapointsused,modelE,modelresid,a1,b1]=n6_getsteps ...
%    (cm,gs,gm,time,ss,a,b,records,gap,lag,tau,modelsel,plotting);
%output 
%par - estimates
%separ - SE 
%model variance
%datapointsused
%model error
%model residuals
%demixing gs
%demixing gm
%
%input
%cm gs gm time
%ss segments
%a b not used
%records altogether
%gap position of stimulus
%lag length of skipped time
%tau tau for transient in the linear model
%modelsel: 1 vannila, 2 trend 3 trend+aftertrend 4 t,at,transient
%plotting probability

demix=0; %input('0 - no demixing: ');

par=zeros(size(ss,2),3,4,3);
separ=zeros(size(ss,2),3,4,3);
modelvar=zeros(size(ss,2),4,3);
datapointsused=zeros(size(ss,2),3);

if ~exist('plotting')
    plotting=0;
end

if plotting
    xxx=repmat([0:2]'.*50,1,size(cm,1))';
end



clear modelvar;       
nofrecords=size(ss,2);       

       for c=1:nofrecords;        
           for d=1:3     
            
           ti_step=time(gap(d),c); 
            
           part1=ss(d*2-1,c):(gap(d)-1);
           part2=(gap(d)+lag):ss(d*2,c);
           ti_lag=time([part1,part2]',c);                      
            
           cm_lag=cm([part1,part2]',c);
           gs_lag=gs([part1,part2]',c);
           gm_lag=gm([part1,part2]',c);
            
           detrendbreaks=[length(part1) length(part1)+1];
           
%---cut a lot away here, the whole detrending issue


           %now setting demix parameters to zero
           a1(c,d)=0;
           b1(c,d)=0;
            
           %if you want to detrend, it should go into a new estimatestep
           %routine, together with passing gm and gs_lag parameters to it,
           %such as
           %[B E F R]=estimatestep([ti_step tau],cm_lag,ti_lag,gm_lag,gs_lag);
           [B E F R]=estimatestep([ti_step tau],cm_lag,ti_lag);                        
           
           datapointsused(c,d)=size(cm_lag,1);
           modelvar(c,d,:)=(mean(R.^2)./sqrt(datapointsused(c,d))');
           modelresid{c,d}=R;
           modelE(c,d,:,:)=E;
            
           par(c,d,:,:)=B(:,:);
           separ(c,d,:,:)=E(:,:);
            
           if plotting
            gcontext=figure(6); set(gcontext,'Name','Linear Model'); clf;
            disp(B); disp(E);
            
            subplot(2,2,1);
            hold off; plot (ti_lag,[cm_lag],'.','MarkerSize',1); hold on;
            plot (ti_lag,squeeze(F),'LineWidth',2);   %added squeeze 28.11.06
            title ('Linear model fits');
            
            subplot(2,2,2);
            plot (ti_lag,squeeze(R)+xxx(1:size(R,1),:),'.','MarkerSize',1);
            title ('Residuals [fF]');
            
            subplot(2,4,5); 
            bar([B(1,:);E(1,:)]'); 
            axis([0.5 3.5 0 10000]);
            title ('Cell size [fF]');
            
            subplot(2,4,6); 
            bar([B(2,:);E(2,:)]'); 
            axis([0.5 3.5 -10 30]);
            title ('Step size [fF]');
            
            subplot(2,4,7); 
            bar([B(3,:);E(3,:)]'); 
            axis([0.5 3.5 -20 20]);
            title ('Overall trend [fF/s]');
            
            subplot(2,4,8); 
            bar([B(4,:);E(4,:)]'); 
            axis([0.5 3.5 -20 20]);
            title ('Post size [fF]');
            
            drawnow;
            end %plotting
            
            end %for d
            
       end %for c
       disp([' Nofrecords: ' int2str(nofrecords)]);
end %function
