function [N,Nold]=n8_reject(steps,sesteps,time,sx,ss,cm,N);

%no overall selection based on segment size
critN=0;
critNN=0;

recind=[1:size(steps,1)]';
t=[1:size(cm,1)];

%put Nans if regions are too short
sxn=sx; sxn(find(sxn<critN))=NaN;

%have N as the sum of both segments
if ~exist('N')
    N=zeros(size(steps));
    N(:,1)=(sxn(1,:)+sxn(2,:))';
    N(:,2)=(sxn(3,:)+sxn(4,:))';
    N(:,3)=(sxn(5,:)+sxn(6,:))'; 
end
    Nbacked=N;
    Nold=N;


%i=find(isnan(N));
%disp(sprintf('%d ',i)); 
i=find(N<critNN);
disp('Rejected records by objective criteria:');    
disp(sprintf('%d ',i)); N(i)=NaN;
disp('----------');

%if step or SE is already NaN because of some preprocessing
i=find(isnan(sesteps));
disp(sprintf('%d ',i)); N(i)=NaN;

i=find(isnan(steps));
disp(sprintf('%d ',i)); N(i)=NaN;

%MANUAL REJECTION ADDED HERE
%click outliers

repeatagain=true;

while repeatagain
for c=1:3 %repeat 3 times
    
    key=1;
    while key~=0
    
    rej=find(isnan(N(:,c)));

    subplot(3,1,1); 
    plot (recind,steps(:,c),'.-',recind(rej),steps(rej,c),'ro');
    ax=axis; %axis([ax(1) ax(2) -5 50]); 
    subplot(3,1,1); xlabel ('Step')
    title ('left = reject, right = accept, middle = inspect, ESC=exit');
    
    subplot(3,1,2); 
    plot (recind,sesteps(:,c),'.-',recind(rej),sesteps(rej,c),'ro');
    ax=axis; axis([ax(1) ax(2) 0 3]); xlabel  ('Step SE')
    
    subplot(3,1,3); 
    sxind=[c*2-1:c*2];
    plot (recind,sx(sxind,:)','.-',recind(rej),sx(sxind,rej),'ro');
    ax=axis; axis([ax(1) ax(2) 0 1000]); xlabel ('Segment size');
    
    %a loop where one may click
    [x,y,key]=ginput(1);
        x=round(x);
            if isempty(x)
                x=0;
            end
            
            if (x<1) | (x>length(recind))
                key=0;
            end
        
            if key==1
                N(x,c)=NaN;
            end

            if key==2
                N(x,c)=Nbacked(x,c);
            end

            if key==3 & exist('cm')
                subplot(3,1,1);
                plot (t(:),cm(:,x),'b', ...
                t(ss(1,x):ss(2,x)),cm(ss(1,x):ss(2,x),x),'r', ...
                t(ss(3,x):ss(4,x)),cm(ss(3,x):ss(4,x),x),'r', ...
                t(ss(5,x):ss(6,x)),cm(ss(5,x):ss(6,x),x),'r');
                ginput(1);
            end
        
            if key==27
                key=0; 
            end
            
    end %while
end %for



%select time region that is useful


disp('Select useful region');

rej=find(isnan(N));
hold off; subplot(1,1,1); 
errorbar (time,steps,sesteps,'o:'); hold on;
plot (time(rej),steps(rej),'k.'); hold off;
ax=axis;axis([0 ax(2:4)]);

%left/right selection
if true
title ('Click left and right extremes of usable data')
[x,y,key]=ginput(2);
    %if (x>min(time(:))&(x<max(time(:))))

N(find((time<x(1))|(time>x(2))))=NaN;
rej=find(isnan(N));
subplot(2,1,2); plot (time,steps,'o:',time(rej),steps(rej),'k.');
ax=axis;axis([0 ax(2:4)]);
end

if isempty(input('Press enter if no additional revision is necessary'))
    repeatagain=false;
end

end %while    

disp('Rejected subjectively');
disp(sprintf('%d ',rej));
disp('-----');
   
end %function