function [returndata ti gs gm cm gap a b Cslow Gseries Time]=n_import;
%function [returndata ti gs gm cm gap a b Cslow Gseries Time]=n_import;
%--------------------------------------------------------------------------
%STEP ONE: LOAD THE FILE

loadworkspace=input('Import a HEKA file (0) or load a MatLab workspace (1)? ');

if ~isscalar(loadworkspace) 
    loadworkspace=0;
end

if loadworkspace
    %load 
    clear A
    [filename filepath]=uigetfile('*.mat','open workspace');
    load ([filepath filename]);
else    
    %load .ASC file 
    [A, B, records, tiling, headerline, Counts, Samples, ...
    Time, Cslow, Gseries, Sweepnames]  = lkinread;
    oldrecords=records;
    
   
end
 
%import adjustment if A was not saved
%and gs,gm,cm instead were 
if ~exist('A')
    disp('Warning: recreating A from gs,gm,cm, physical units may be changed');
    disp('This is run only in case of importing the clicks from MSc Thesis')
    disp(mean([gs(:),gm(:),cm(:)])');
    %make the physical units nS and fF
    change=input('Change physical units? Enter factors as [gs gm cm]');
    if length(change)==3
        gs=gs.*change(1);
        gm=gm.*change(2);
        cm=cm.*change(3);
    end
    
    time=repmat(ti,1,records);
    A=[time(:),gs(:),gm(:),cm(:)];
    
    Sweepnames=filename;
    clear gs gm cm;
end    

clear loadworkspace proposedname filepath filename

%don't forget that some records could be padded at the end with zeros

   [time,gs,gm,cm,cuts,recordsizes]=cutrecords(A);
   
   %new feature of heka 8.77, first sample crap; dispose!!!
    time=time(2:end,:);
    gs=gs(2:end,:);
    gm=gm(2:end,:);
    cm=cm(2:end,:);
    %Samples=Samples-1;
   
    recordsizes=recordsizes-1;
    maxrecordsize=max(recordsizes);
    reclength=min(recordsizes);
    records=size(recordsizes,1)
    %display median values of the traces
    disp(median([gs(:),gm(:),cm(:)])');
    
%make the time vector
    
    ti=(time(1:reclength))';
    dti=diff(ti);
    sampletime=median(dti); 
    
%conversions nS / fF
    gs=gs.*1e9;
    gm=gm.*1e9;
    cm=cm.*1e15;
    disp(mean([gs(:),gm(:),cm(:)])');

%-----------------------------------------------------------------------    
%PARAMETERS AND CONSTANTS
    segmentlength=floor(1./sampletime); %for nonlinear fit (sec)
    demixsegment=floor(0.2./sampletime); %for demix (sec)
    
    %setting for 1 kHz sampling;
    %has to be checked whether it works or not
    
    percenttrim=25; %for trimmed mean
    annotend=500; %we will not analyse more than 400 records
    detrendtype='constant'; %for demixing;
%-----------------------------------------------------------------------            
    %FIND AND ACKNOWLEDGE THE GAPS
    gca=figure(1); clf; whitebg ([0 0 0]);
    set(gca,'Name','Stimulus Timings'); 
    subplot(3,1,1); plot (diff(time),'o-');
    subplot(3,1,2); plot (mean(detrend(cm,'linear')'));
    gap=find(dti>2*sampletime)+1;
    disp ('Sample time [s]');
    disp (sampletime);
    disp ('index of gaps and their length [s]')
    disp(gap);
    disp(dti(gap-1));
    
    %if the gap number is not three ...
    while length(gap)~=3
        gap=input('enter the threee gaps in the format [a b c] with brackets');
        disp(gap);
    end

    gapstim=input('which gap holds the stimulus?' );
    stims=(diff(time((gap(gapstim)-1):gap(gapstim)+0,:))');
    subplot(3,1,3); plot (stims,'o-');    
%-----------------------------------------------------------------------

%STEP TWO
    %truncate the end of the experiment
    [records]=n2_truncate(ti,gs,gm,cm,records,reclength,gap,annotend);
    gs=gs(:,1:records);
    gm=gm(:,1:records);
    cm=cm(:,1:records);
    time=time(:,1:records);

%-----------------------------------------------------------------------

%STEP FOUR
    %calulate the demix coefficient; 
    %'linear' or 'constant' 
    %linear seems to work better 
    %so let us use it, a?
    %of course, the formula or the demixing is then still
    %Cm*=Cm-mean(a).*detrend(Gs,'linear');
    
%[agscm rgscm]=n4_demix_01(gs,cm,records,gap,demixsegment,detrendtype);
%[agmcm rgmcm]=n4_demix_01(gm,cm,records,gap,demixsegment,detrendtype);

%calculate the demixing coefficients for each invididual trace
containsstim=ceil(gap(gapstim)/demixsegment);
%a=trimmean(agscm([(1:containsstim-1) (containsstim+1:end)],:),percenttrim);
%stda=std(agscm([(1:containsstim-1) (containsstim+1:end)],:));
%b=trimmean(agmcm([(1:containsstim-1) (containsstim+1:end)],:),percenttrim);
%stdb=std(agmcm([(1:containsstim-1) (containsstim+1:end)],:));
%r=trimmean(rgscm([(1:containsstim-1) (containsstim+1:end)],:),percenttrim);
%r2=trimmean(rgmcm([(1:containsstim-1) (containsstim+1:end)],:),percenttrim);

%do some plotting
%gca=figure(4); clf; whitebg([1 1 1]);
%set (gca,'Name',['Detrending and R']);

%subplot(3,2,1); 
%plot (1:records,agscm','b.', ...
%    1:records,a,'m-','MarkerSize',1);
%    title ('Demixing coefficient gs (fF/nS)');
%subplot(3,2,2);
%plot (1:records,agmcm','b.', ...
%    1:records,b,'m-','MarkerSize',1);
%    title ('Demixing coefficient gm (fF/nS)')
%subplot(3,2,3);
%    plot (agscm(:),'b.','MarkerSize',1);
%    title('Demixing coefficients gs over the whole experiment');
%subplot(3,2,4);
%    plot (agmcm(:),'b.','MarkerSize',1);
%    title('Demixing coefficients gm over the whole experiment');
%subplot(3,2,5);
%    plot (agscm,'b.','MarkerSize',1);
%    hold on; plot(mean(agscm'),'r'); 
%    plot(mean(agscm')+iqr(agscm'),'m'); 
%    plot(mean(agscm')-iqr(agscm'),'m'); 
%    hold off; title ('Segmentwise gs demixing coefficient')
%    subplot(3,2,6);
%    plot (agmcm,'b.','MarkerSize',1);
%    hold on; plot(mean(agmcm'),'r'); 
%    plot(mean(agmcm')+iqr(agmcm'),'m'); 
%    plot(mean(agmcm')-iqr(agmcm'),'m'); 
%    hold off; title ('Segmentwise gm demixing coefficient')

    
%-----------------------------------------------------------------------
%STEP FIVE 
    %estimate the time constant for the transients
    %we will use it afterwards in the nested model
    %for the transient
    
    %since the demixing does not depend on it, we will 
    %use it first to adjust the lag for the demixing
    %we will go for the usual 3-times tau to be on the safe side
    
    %if input('Do you want to fit (1) or has this already been done (0)?');
    if true
    
    gca=figure(2); whitebg ([0 0 0]);

    set(gca,'Name','Fitting');
    subplot(3,1,1); plot (ti-ti(gap(gapstim)),median(detrend(gs,'linear')')); title ('Gs');
    subplot(3,1,2); plot (ti-ti(gap(gapstim)),median(detrend(gm,'linear')')); title ('Gm');
    subplot(3,1,3); plot (ti-ti(gap(gapstim)),median(detrend(cm,'linear')')); title ('Cm');
    disp('Have a look at the transient taus and then press key');
    pause; 
    
    tau=input('Apparent time constant (0.01s)');
    if isempty(tau) tau=0.01; end
    %tau=input('Apparent time constant in gm ');
    %tau=input('Apparent time constant in cm ');
        [tau_gs,setau_gs]=n5_estimatetau(gs,ti,gap(gapstim),tau,segmentlength,percenttrim);
        pause
        [tau_gm,setau_gm]=n5_estimatetau(gm,ti,gap(gapstim),tau,segmentlength,percenttrim);
        pause
        [tau_cm,setau_cm]=n5_estimatetau(cm,ti,gap(gapstim),tau,segmentlength,percenttrim);
        pause
    end
    
    disp('estimated Time constants are: ');
    tauhat=([tau_gs,tau_gm,tau_cm]');
    tause=([setau_gs,setau_gm,setau_cm]');
    disp('hat(tau) gs gm cm')
    disp(tauhat)
    disp('SE(tau) gs gm cm')
    disp(tause)
    tausel=input('Which tau do you trust? (1)');
    if isempty(tausel) || ~isscalar(tausel)
        tausel=1;
    end
    tau=tauhat(tausel);
    
    disp('3-times tau lag as samples');
    lag=max((find(ti<tau*3)));
    disp(lag);
    
    newlag=input('how many samples do you want to skip in the nested model? ');
    if ~isempty(newlag)
        lag=newlag;
    end
%---------------------------------------------------------------------
%save
    clear B Counts annotend c cf cuts demixsegment detrendtype f1 f2 
    clear forder gca headerline newlag oldrecords percenttrim proposedname
    clear tauhat tause tausel tiling
    
    proposedname=['fit_' Sweepnames(1:end-4) '.mat'];
    disp (proposedname);
    skipsave=input('Save the annotation and fit? (1-no 0-yes)');
    if ~isscalar(skipsave) 
        skipsave=false; 
    end
    
    if ~skipsave
        [filename filepath]=uiputfile(proposedname,'save workspace');
        clear time gs gm cm ti;
        save (fullfile(filepath,filename));
        disp('Function will now end.');
    end
    
returndata=[records sampletime tau lag];    
%-----------------------------------------------------------------------    
end %function